LeetCode: 575. Distribute Candies

LeetCode: 575. Distribute Candies

Given an integer array with even length, where different numbers in
this array represent different kinds of candies. Each number means one
candy of the corresponding kind. You need to distribute these candies
equally in number to brother and sister. Return the maximum number of
kinds of candies the sister could gain.

Example 1: Input: candies = [1,1,2,2,3,3] Output: 3 Explanation: There
are three different kinds of candies (1, 2 and 3), and two candies for
each kind. Optimal distribution: The sister has candies [1,2,3] and
the brother has candies [1,2,3], too. The sister has three different
kinds of candies. Example 2: Input: candies = [1,1,2,3] Output: 2
Explanation: For example, the sister has candies [2,3] and the brother
has candies [1,1]. The sister has two different kinds of candies, the
brother has only one kind of candies.

Note:

The length of the given array is in range [2, 10,000], and will be
even. The number in given array is in range [-100,000, 100,000].

public class Solution {
    public int distributeCandies(int[] candies) {
        int length = candies.length;
        int half = (int) (length / 2);
        int[] arrays = new int[200001];
        for (int i = 0; i < length; i++) {
            arrays[candies[i] + 100000]++;
        }
        int result = 0;
        for (int i = 0; i < arrays.length; i++) {
            if (arrays[i] > 0) {
                result++;
                if (result > half) {
                    return half;
                }
            }
        }
        return result;
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
给定一个整数数组 nums 和一个目标值 target,要求在数组中找出两个数的和等于目标值,并返回这两个数的索引。 思路1:暴力法 最简单的思路是使用两层循环遍历数组的所有组合,判断两个数的和是否等于目标值。如果等于目标值,则返回这两个数的索引。 此方法的时间复杂度为O(n^2),空间复杂度为O(1)。 思路2:哈希表 为了优化时间复杂度,可以使用哈希表来存储数组中的元素和对应的索引。遍历数组,对于每个元素nums[i],我们可以通过计算target - nums[i]的值,查找哈希表中是否存在这个差值。 如果存在,则说明找到了两个数的和等于目标值,返回它们的索引。如果不存在,将当前元素nums[i]和它的索引存入哈希表中。 此方法的时间复杂度为O(n),空间复杂度为O(n)。 思路3:双指针 如果数组已经排序,可以使用双指针的方法来求解。假设数组从小到大排序,定义左指针left指向数组的第一个元素,右指针right指向数组的最后一个元素。 如果当前两个指针指向的数的和等于目标值,则返回它们的索引。如果和小于目标值,则将左指针右移一位,使得和增大;如果和大于目标值,则将右指针左移一位,使得和减小。 继续移动指针,直到找到两个数的和等于目标值或者左指针超过了右指针。 此方法的时间复杂度为O(nlogn),空间复杂度为O(1)。 以上三种方法都可以解决问题,选择合适的方法取决于具体的应用场景和要求。如果数组规模较小并且不需要考虑额外的空间使用,则暴力法是最简单的方法。如果数组较大或者需要优化时间复杂度,则哈希表或双指针方法更合适。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值